<?php
############################################################################
# A Project of TNET Services, Inc.
############################################################################
#
#	Project:	Sample Included Website Design
#	Module:		index.php
#	Purpose:	The main index page
# 	Authors:	Kevin W. Reed <kreed@tnet.com>
#				TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
#	This document uses Tab 4 Settings
#
############################################################################
require_once("Settings.php");
require_once("common.php");
############################################################################
$TITLE="TNET Services, Inc. - Constructing an Included Web Page System";
include("top.php");
############################################################################
?>
</head><body>
<?php
############################################################################
include("header.php");
############################################################################
include("menubar.php");
############################################################################
?>

<div id="main-copy">
	<div id="begin" class="boxLighter">
		
	<h1>TNETWeather Notebook - Constructing an Included Web Page System</h1>
	
	<p>This series of pages is part of the TNET Weather notebook pages that demonstrate how
	to do various functions in a weather station environment.</p>
</div>

	<div id="begin2" class="boxLighter">
	
	<h1>Constructing an Included Web Page System</h1>
	
	<p>These pages show how you can create a series of included files that will enable you to build a large website with
	common features.  The result is that you can then update sections of ALL pages, by making changes to common
	included files rather than having to make the changes to every page in the system every time you want a main component to
	change.</p>
	
	<p>These examples use PHP which means you need to have PHP enable web hosting to use them.</p>
	
		<div id="picture1" class="picfr">
		<img src="images/sample_page.png" alt="Picture: Thunbnail of Sample Page" />
	</div>
	<p>There are 6 basic include files that are used to build a page, each of which are described in 
	more detail further down the page (or you can use the menu on the left to jump to them:</p>

	<ul>
		<li>Settings.php</li>
		<li>common.php</li>
		<li>top.php</li>
		<li>header.php</li>
		<li>menubar.php</li>
		<li>footer.php</li>
	</ul>
	
	<p>You can create and add new include files as well as your pages may requirement.  Some examples:</p>
	<ul>
		<li>Weather_math.php - File that contains various weather related math functions</li>
		<li>Clientraw.php - File that contains parsing of clientraw data files and inclusion
		of their data into common arrays that then can be use by each section</li>
		<li>JpGraph.php - Include file to source the JpGraph functions, where they are located etc on
		your web page</li>
	</ul>
	
	<p>You would use those types of includes only on pages that actually needed them.</p>
	
	<p>Below is a discussion of the various sections mentioned above and what their purpose is</p>	

	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
	
	<div id="Settings" class="Section">
		Settings.php
	</div>
	
	<p>This file contains the underlying configuration info used by all pages in the
	website.  It includes a base array called $SITE.  This is loaded with all common defaults
	you want to use for your entire website.</p>
	
	<p>Example:</p>
	
	<pre>
$SITE = array();    	
$SITE['REMOTE_ADDR']    = $_SERVER['REMOTE_ADDR'];
$SITE['REMOTE_HOST']    = $_SERVER['REMOTE_HOST'];
$SITE['WEBROOT']        = $_SERVER['DOCUMENT_ROOT'];
$SITE['REQURI']         = $_SERVER['REQUEST_URI'];
$SITE['SERVERNAME']     = $_SERVER['SERVER_NAME'];

$SITE['organ']  = 'TNET Services, Inc.';
$SITE['copyr']  = '&copy; 1992-2007 Copyright TNET Services, Inc.';
$SITE['remote'] = "onclick=\"window.open(this.href,'_blank');return false;\"";
	</pre>

	<p>Any module that includes this file, can now use any of the configuration settings by simply
	by using the variables like:</p>
	
	<pre>		
global  $SITE;
echo 'The visitor is from ' . $SITE['REMOTE_HOST'] . ' [' . $SITE['REMOTE_ADDR'] . ']&lt;br/&gt;';
	</pre>		
	
	<p>Which would look just like:</p>
	
	<strong>
	<? echo 'The visitor is from ' . $SITE['REMOTE_HOST'] . ' [' . $SITE['REMOTE_ADDR'] . ']<br/>'; ?>
	</strong>


	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
		
	<div id="Common" class="Section">
		common.php
	</div>	
	
	<p>As an example of other types of file includes, this example has a file called common.php.
	
	It would be a place to put common functions that you want to use in your website pages that
	would be common throughout the site.</p>

	<p>The Example included is a URL function called: <strong>MkLink</strong>:</p>
	
	<div class="code">
	MkLink( $url, $title, $desc, $type );<br/>
	</div>
	
	<p>The four variables are.  $usr which is the URL for the link.   $title  which is what is placed on the 
		URL title element, $desc which is what the link will have, and $type which a flag indicating
		if the page is internal or external.  A 1 would make it External and a marker would be placed on the
	URL displayed indicating it will leave the site.</p>
	
	<p>Using code like:</p>
	
	<div class="code">
		 MkLink("http://www.mwcil.org", "MetroWest Website", "MWCIL WEBSITE", 1);<br/>
	</div>	
	
	<p>would generate browser code like:</p>
	
	<div class="code">
		&lt;a href="http://www.mwcil.org" title="MetroWest Website"<br/>
		  &nbsp;&nbsp; onclick="window.open(this.href,'_blank');return false;">MWCIL WEBSITE&lt;/a&gt;<br/>
		&nbsp;&nbsp; &lt;img src="/images/offsite.gif" alt=">>"/&gt;<br/>
	</div>
	
	<p>and the visitor would see:</p>
	
	<? MkLink("http://www.mwcil.org", "MetroWest Website", "MWCIL WEBSITE", 1); ?> 
	
		<p>An example of this function can be found used in other sections of these sample
			pages such as in the menubar.php, 404.php.</p>
		
	<br/>	
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
		
	<div id="Top" class="Section">
		top.php
	</div>		
	
	<p>The top.php file is the first output for the page.  It includes all the common HTML 
	document info such as DocType, HTML start, Meta tags, Sytle Sheet definitions etc...</p>
	
	<p>This file stops just short of sending out the &lt;/head&gt; ending element tag so that
	you can include (in the main page), special Javascript or other code that needs to be in
	the HEAD section for that specific page.</p>
		
	<p>Some of the definitions in the top section are obtained from the Settings.php file</p>
	
	<p>Example:</p>
	
	<pre>
&lt;?php
############################################################################
require_once("Settings.php");
global  $TITLE;
############################################################################
?&gt;
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-US"&gt;
&lt;head&gt;
    &lt;meta http-equiv="content-type" content="application/xhtml+xml; charset=ISO-8859-1" /&gt;
    &lt;meta name="author" content="TNET Services, Inc." /&gt;
    &lt;meta name="generator" content="TNET Services, Inc." /&gt;
    &lt;meta http-equiv="Cache-Control" content="no-cache" /&gt;
    &lt;meta http-equiv="Pragma" content="no-cache" /&gt;
    &lt;meta http-equiv="Expires" content="-1" /&gt;
    &lt;meta name="robots" content="index,nofollow" /&gt;
    &lt;meta name="DC.title" content="TNET Services, Inc." /&gt;
    &lt;meta name="description" content="TNET Services Inc. demonstration included file web template."/&gt;
    &lt;meta name="keywords" content="TNET,TNET Services Inc,TNET Weather,Arizona,web design,graphics,weather"/&gt;
    &lt;link rel="stylesheet" type="text/css" href="screen.css" media="screen" title="Main (screen)" /&gt;
    &lt;link rel="shortcut icon" href="/favicon.ico" type="image/x-icon" /&gt;
&lt;?php
if( isset ($TITLE) ) {
    echo "&lt;title&gt;" . $TITLE . "&lt;/title&gt;\n";
} else {
    echo "&lt;title&gt;" . $SITE['organ'] . "&lt;/title&gt;\n";
}
	</pre>
		
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
	
	<div id="Header" class="Section">
		header.php
	</div>			
	
	<p>The header.php file basically contains the top of the web page that you see on every page. It
	includes the logo for the site and in this example, a datetime stamp.</p>
	
	<p>Note tha the timezone for obtaining the date and time is set in the Settings.php file.</p>
	
	<p>Example:</p>
	
	<pre>
&lt;?php
############################################################################
require_once("Settings.php");
############################################################################
?&gt;

&lt;div id="header"&gt;
    &lt;h1 class="headerTitle"&gt;
    &lt;a href="index.php" title="Browse to homepage" lang="en"&gt;
        &lt;img src="images/tnet-logo01.gif" alt="TNET Services, Inc."/&gt;&lt;/a&gt;
    &lt;/h1&gt;       
    &lt;div class="headerLinks"&gt;
        &lt;? putenv($SITE['tz']); ?&gt;
        &lt;? echo date("D M j, Y g:i A"); ?&gt; &lt;?=$SITE['tzname'];?&gt;
    &lt;/div&gt;
&lt;/div&gt;  	
	</pre>
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
	
	<div id="Menubar" class="Section">
		menubar.php
	</div>	
	
	<p>The menubar.php file.... this is the menu used by the site.  It could be used as a menu across
	the top of the page, or as in this example, as a menu down the left side of the page.</p>
	
	<p>The menubar is one of those things that you change as you add new pages and since it is 
	enclosed in this sample, all you need to do is edit it, and every page will get the new
	contents the next time they are refreshed.</p>
	
	<p>Note that you could use a Javascript menuing system here as well, you just need to make sure
	that if there are any require Javascript libraries, they are included in the top.php file.</p>
	
	<p>You can get fancy with the menubar as well, by setting a global variable before including
	the menubar file, you can then within the menubar highlight or do other functions based on
	what setting was passed.</p>
	
	<p>Example:</p>
	
	<pre>
&lt;?php
############################################################################
require_once("Settings.php");
############################################################################
?&gt;
   &lt;div id="menu-bar"&gt;
      &lt;p class="menuBarTitle"&gt;Site Navigation&lt;/p&gt;
        &lt;ul&gt;
            &lt;li&gt;&lt;? MkLink("http://www.tnet.com/index.php","Home Page","TNET Home Page",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("index.php","Main Page","Main Page",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("sample.php","Sample Page","Sample Blank Page",0); ?&gt;&lt;/li&gt;
        &lt;/ul&gt;
        &lt;br/&gt;
        
      &lt;p class="menuBarTitle"&gt;Jump Links&lt;/p&gt;
        &lt;ul&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Settings","Settings","Setting File",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Top","Top","Top File",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Header","Header","Header File",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Menubar","Menubar","Menubar File",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Footer","Footer","Footer File",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Content","Content","All Together",0); ?&gt;&lt;/li&gt;
            &lt;li&gt;&lt;? MkLink("/index.php#Other","Other","Other files used",0); ?&gt;&lt;/li&gt;
        &lt;/ul&gt;
        &lt;br/&gt;       
    &lt;/div&gt;	
	</pre>
	
	<p>Note the use of MkLink function for the links... this was obtained from the Settings.php file</p>

	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
			
	<div id="Footer" class="Section">
		footer.php
	</div>	
	
	<p>This file contains the bottom of the displayable page for every page.  It could contain
	page counters, validation information or other code that needs to be on every page</p>
	
	<p>Example:</p>
	
	<pre>
&lt;?php
############################################################################
require_once("Settings.php");
############################################################################
?&gt;
&lt;div id="footer"&gt;
    &lt;div class="left doNotPrint"&gt;
        &lt;a href="http://validator.w3.org/check/referer"&gt;Valid XHTML 1.0&lt;/a&gt; |
        &lt;a href="http://jigsaw.w3.org/css-validator/check/referer"&gt;Valid CSS&lt;/a&gt; 
    &lt;/div&gt;

    &lt;div class="right"&gt;
        Modified: &lt;?php echo date("F d Y H:i:s", getlastmod()); ?&gt; MST
        &lt;br/&gt;
    &lt;/div&gt;
&lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;	
	</pre>
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>	
		
	<div id="Content" class="Section">
		Putting it All Together
	</div>	
	
	<p>Now you can put all the above together into a page by including the various files
	into a complete page.</p>
	
	<p>Below is the source of the sample page showing all the sections above put into a 
	single page</p>
	
	<pre>
&lt;?php
############################################################################
# A Project of TNET Services, Inc.
############################################################################
#
#   Project:    Sample Included Website Design
#   Module:     sample.php
#   Purpose:    Sample Page
#   Authors:    Kevin W. Reed &lt;kreed@tnet.com&gt;
#               TNET Services, Inc.
#
#   Copyright:  (c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
require_once("Settings.php");
require_once("common.php");
############################################################################
$TITLE="TNET Services, Inc. - Sample Blank Page";
include("top.php");
############################################################################
?&gt;
&lt;/head&gt;&lt;body&gt;
&lt;?php
############################################################################
include("header.php");
############################################################################
include("menubar.php");
############################################################################
?&gt;

&lt;div id="main-copy"&gt;
    &lt;div id="top" class="boxLighter"&gt;
    
	&lt;h1Sample Blank Page&gt;		    
    
    &lt;p&gt;This is a sample Blank Page&lt;/p&gt;

    &lt;p&gt; &lt;/p&gt;
    &lt;/div&gt;
&lt;/div&gt;
&lt;?php
############################################################################
include("footer.php");
############################################################################
# End of Page
############################################################################
</pre>	

	<p>You can see the above in action by using the following link:</p>
	
	<?php MkLink("sample.php","Sample","Sample Page",0); ?> <br/> <br/>
	
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
		
	<div id="Other" class="Section">
		Other Files Used in This Sample
	</div>		

	<p>Also used in these sample pages are</p>
	<ul>
		<li>screen.css<br/>
			The external CSS Style sheet used for these example pages.</li>
		<li>images directory<br/>
			Contains any images used by these example pages</li>
		<li>404.php file<br/>
			A page used to redirect 404 and 403 errors to.  Uses the same structure used by these
			example pages to provide an additional example.</li>		
		<li>.htaccess file
			Used to redirect the error to the 404.php page. You would need to create this file for this to work.
			It would Contains the following assuming your pages are in the root of your webspace:
		<pre>
ErrorDocument 401 /index.php
ErrorDocument 403 /index.php
ErrorDocument 404 /404.php  	
		</pre>
			</li>
	</ul>
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
		
	<div id="Use" class="Section">
		Use of this material, examples
	</div>		

	<p>&copy; 1992-2007 Copyright TNET Services, Inc.</p>
	
	<p>These scripts and included examples are free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.</p>
	
	<p>Inclusion of a credit link on your pages would be greatly appreciated:</p>
	
	<p>Possible Credit Link:<br/>
	
	<i>Based partially on code provided by TNET Services, Inc. - http://www.TNETWeather.com</i></p>
	
	<br/>

	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
	
	<div id="Support" class="Section">
		Support
	</div>		
	
	<p>As this is free software under the terms and conditions listed above, there is no 
		support for this code for non-clients.  However, if you have questions about the
	code, you can send email to the following email address, and if time permits, I will respond.</p>

	&nbsp; &nbsp; <strong> weather&#64;tnetweather.com</strong><br/> <br/>
	
	<p>If you are looking for paid client support for this or other items, please contact:</p>
	
	&nbsp; &nbsp; <strong> support&#64;tnet.com</strong><br/> <br/>
	
	
	<br/>
	
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
	
	<div id="Download" class="Section">
		Download Source Code
	</div>		
	
	<p>The source code is built to be relative so that if you create a subdirectory on your currentw
		website and unpack the contents, you will have a self-contained website that will not interfer
	with your current website</p>
	
	<p>There are two versions, a Zip version and a Tar gzip'd version.  Both contain the same source
	code in tab 4 format.</p>
	
	<p>Please refer to Use of this Material above for copyright and other related info.</p>
	
	<? MkLink("inclusion-example.tar.gz","inclusion-example.tar.gz","Download inclusion-example.tar.gz", 1); ?>
	<? MkLink("inclusion-example.zip","inclusion-example.zip","Download inclusion-example.zip", 1); ?>
	
	<br/>
	
	<?php MkLink("index.php#header","Back to Top","Back to Top",0); ?> <br/> <br/>
		
	<p> </p>
	</div>
</div>
<?php
############################################################################
include("footer.php");
############################################################################
# End of Page
############################################################################
